#!/bin/bash

#############################################################################
#  Gradio un programa de Automatización de radio programado en bash  #
#			  Última actualización: 5-Ago-2017		    #
#############################################################################
#	     Projecto iniciado el 16 de junio de 2011	    		    #
#############################################################################
#############################################################################
#                                                                           #
# This program is free software; you can redistribute it and/or modify it   #
# under the terms of the GNU General Public License as published by the     #
# Free Software Foundation; either version 2 of the License or any later    #
# version.								    #
#									    #
# This program is distributed in the hope that it will useful, but WITHOUT  #
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or     #
# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License     #
# for more details.							    #
#									    #
############################################################################# 

echo "======================================================="
echo "G Radio -v:refundation ***Carga Lista****"
salir=0
nlinea=1
playlist=0
#agresividad=`cat ~/.gradio/data/tmp/agresividad`
agresividad=600
log=1

while [ $salir=0 ]; do  #1
	listatemas=14
	hora=`date  +%-H` 
	dia=`date +%u`
	fecha=`date +%-9d-%-m-%-Y-%-H_%-M`
	Fecha=`date +%-9d-%-m-%-Y`

	##Determinar el número de lineas playlist de la lista
	ranura=`echo "$hora-$(($hora+1)).mus"`
	nlineas=`grep -c $ ~/.gradio/data/parrilla/$dia/$ranura|grep -v "^[ ]*$" `
	hora1=`date  +%-H` 
	#playlist=0
	if [ $log = 1 ]; then
		echo "log: $log $fecha - la ranura tiene: $nlineas lineas y nlinea parte de: $nlinea" >> ~/.gradio/data/tmp/gr-$Fecha.log
	fi
	while [ $hora = $hora1 ]; do  #Xhile 2 de hora
		#Construye un playlis de n temas
		playlist=`grep -c $ ~/.gradio/data/tmp/playlist|grep -v "^[ ]*$"`
		if [ $log = 1 ]; then
			echo "playlist inicial: $playlist salir: $salir" >> ~/.gradio/data/tmp/gr-$Fecha.log
		fi
		while [ $playlist -le $listatemas ]; do #Xhile 3 playlist menor a 14 #######################################################################################3
			caracteres=`wc -m ~/.gradio/data/parrilla/$dia/$ranura|cut -d " " -f 1`
			if [[ $caracteres -gt $listatemas ]]; then #fi #1
				nlinea=1 					
				while [ $nlinea -le $nlineas ]; do #Xhile 4 lineas de parrilla
					caracteres=`wc -m ~/.gradio/data/parrilla/$dia/$ranura|cut -d " " -f 1`
					if [ $log = 1 ]; then
						echo "linea $nlinea de $nlineas de la ranura $ranura"  >> ~/.gradio/data/tmp/gr-$Fecha.log
					fi

					line="`sed -n $nlinea"p" ~/.gradio/data/parrilla/$dia/$ranura`" 

					if [[ $hora = $hora1 ]]; then #fi3
						ouch=0		
						if [[ "$line" = "Hora" ]]; then #fi4 Carga la hora
							echo Hora >> ~/.gradio/data/tmp/playlist	
							randomfile="Hora"
							echo "Cargada hora" >> ~/.gradio/data/tmp/gr-$Fecha.log
							echo "<font size="1" color="green"><b>$randomfile</b></font></br>" >> ~/.gradio/data/tmp/playlistweb
							echo "$randomfile" >> ~/.gradio/data/tmp/playlistg3
						else #fi4
							line=`echo -e "${line}"|sed  s/\'//g` #Con asterisco					
							line=`echo -e "${line}"|sed  s/"*"/""/g` #|sed  s/" "/"\\\\ "/g` #sin esterisco y limpiadoa
							if [[ -f "$line" ]]; then #Es archivo; se valida y envía al playlist
								extension="${line##*.}"
								validado=`grep -i $extension ~/.gradio/data/extensiones`
								if [ "$validado" != "" ]; then #fi5 es archivo?
									randomfile=$line
									duracion=`mplayer -ao null -identify -frames 0 "$randomfile" 2>&1 | grep ID_LENGTH|awk -F"=" '{print $2}'|awk -F "." '{print $1}'`
									duracionview=$(printf '%dh:%dm:%ds\n' $(($duracion/3600)) $(($duracion%3600/60)) $(($duracion%60)))
									nombrebase=`echo "$randomfile" |awk -F/ '{print $NF}'`
									echo "$randomfile" >> ~/.gradio/data/tmp/playlist 
									echo "<font size='1' color='green'><b>$nombrebase</b></font></br>" >> ~/.gradio/data/tmp/playlistweb
									echo "$nombrebase" "["$duracionview"]" >> ~/.gradio/data/tmp/playlistg3					
								fi #es archivo?

							else #fi5 es directorio;
								if [[ -d "$line" ]]; then # Es directorio; se hace un random de la carpeta
									files=`ls -R "$line"|grep -f ~/.gradio/data/extensiones|grep -c $` # Número de archivos del listado
									#if [ $log = 1 ]; then
									#	echo "existen $files archivos en la carpeta $line" >> ~/.gradio/data/tmp/gr-$Fecha.log
									#fi
									if [[ $ouch = 0 ]]; then #fi6
										yatocado=1
										infinito=0
										encabezado=""
										while [[ $yatocado = 1 || $encabezado != "" ]]; do #Xhile 5 ya tocado
											#agresividad=`cat ~/.gradio/data/tmp/agresividad`
											randomico=$((RANDOM % $files))
											if [ $log = 1 ]; then
												echo "randomico:" $randomico >> ~/.gradio/data/tmp/gr-$Fecha.log
											fi
											if [[ $randomico != 0 ]]; then #00			
												temabase="`ls -R "$line"|grep -f ~/.gradio/data/extensiones|sed -n $randomico"p"`"
												#if [ $log = 1 ]; then
												#	echo "temabase loop" "$temabase" >> ~/.gradio/data/tmp/gr-$Fecha.log
												#fi
												encabezado=`echo "$temabase"|grep \/:`
											#	echo "encabezado loop" $encabezado >> ~/.gradio/data/tmp/gr-$Fecha.log
												if [[ $encabezado = "" ]]; then
													randomfile=`find "$line" -name "$temabase" -print|sed -n 1p`
													ruta=`echo "$randomfile"|awk -F'/[^/]*$' '{print $1}'` #sed s/"\/$nombrebase"//g`
													echo "ruta para elegir $ruta"  >> ~/.gradio/data/tmp/gr-$Fecha.log
													
													if [ -s "$ruta"/.historico.mus ]; then #filtrado de histórico y borrado de mus
													echo "si existe archivo histórico .mus" >> ~/.gradio/data/tmp/gr-$Fecha.log
														randomfile=`ls "$ruta"|grep -f ~/.gradio/data/extensiones|grep -v -f "$ruta"/.historico.mus|sort -R|head -n 1`
														echo "randomfile a comparar $randomfile"  >> ~/.gradio/data/tmp/gr-$Fecha.log
														if [[ $randomfile = "" ]]; then
															echo "todos los temas de $ruta .mus han sido tocados, se borra .mus" >> ~/.gradio/data/tmp/gr-$Fecha.log
															rm "$ruta"/.historico.mus
															randomfile=`ls "$ruta"|grep -f ~/.gradio/data/extensiones|sort -R|head -n 1`
														fi
														echo "se elige $randomfile" >> ~/.gradio/data/tmp/gr-$Fecha.log

														##Filtrado de lista
														encola=`cat ~/.gradio/data/tmp/playlist|grep "$randomfile"`
														if [[ "$encola" != "" ]]; then
															echo "el tema $encola ya está en el playlist" >> ~/.gradio/data/tmp/gr-$Fecha.log
															randomfile=""
														fi
														#echo  "randomfile final $randomfile"
														if [[ "$randomfile" != "" ]]; then
															yatocado=0
														fi
													else
													echo "no existe archivo de históricos .mus" >> ~/.gradio/data/tmp/gr-$Fecha.log
														temas=`ls "$ruta"|wc -l`
														echo "la carpeta $ruta tiene: $temas temas" >> ~/.gradio/data/tmp/gr-$Fecha.log
														randomfile=`ls "$ruta"|grep -f ~/.gradio/data/extensiones|sort -R|head -1`
														if [[ $temas -le 14 ]]; then
															yatocado=0
															echo "Esta carpeta tiene menos de 15 temas, no puedo calcular randómico" > ~/.gradio/data/tmp/currentcomercial.txt
															echo "Esta carpeta tiene menos de 15 temas, no puedo calcular randómico" >> ~/.gradio/data/tmp/gr-$Fecha.log															
														else
															encola=`cat ~/.gradio/data/tmp/playlist|grep "$randomfile"`
															if [[ "$encola" != "" ]]; then
																echo "el tema $encola ya está en el playlist" >> ~/.gradio/data/tmp/gr-$Fecha.log
																randomfile=""
															fi
															if [[ "$randomfile" != "" ]]; then
																yatocado=0
															fi
														fi
														echo "tema generado $randomfile" >> ~/.gradio/data/tmp/gr-$Fecha.log
														#grep -v "$enlista"|
													fi
													#echo "randomfilefinal: $randomfile" #> ~/.gradio/data/tmp/currentcomercial.txt
												fi
												if [[ "$randomfile" != "" ]]; then #fi7
													extension="${randomfile##*.}"
													validado=`grep -i $extension ~/.gradio/data/extensiones`
													if [ "$validado" != "" ]; then #fi8	
														#echo "extensión desde randomico" $extension #>> ~/.gradio/data/tmp/gr-$Fecha.log
														valido=1
													else
														#echo "no cumple extension" >> ~/.gradio/data/tmp/gr-$Fecha.log				
														valido=0
													fi #fi8											
												fi #00	
												#encabezado=`echo $temabase|grep \/:`										
												ouch=0										
											fi #ouch fi 7									
											infinito=$(($infinito +1))
											echo "intentos: $infinito" > ~/.gradio/data/tmp/currentcomercial.txt
											#echo "infinito" $infinito
											if [[ $files -lt 5 || $infinito -gt $agresividad ]]; then 
												yatocado=0												
											fi
									
											if [[ $infinito -gt $agresividad && -s "$ruta"/.historico.mus ]]; then
												rm "$ruta"/.historico.mus
												echo "se superaron $agresividad intentos, se borra $ruta historico.mus"
											fi
										done #Xhile 5 ya tocado
											randomfilefinal="$ruta/$randomfile"
											
											duracion=`mplayer -ao null -identify -frames 0 "$randomfilefinal" 2>&1 | grep ID_LENGTH|awk -F"=" '{print $2}'|awk -F "." '{print $1}'`
											if [[ $duracion -gt 0 ]]; then
											duracionview=$(printf '%dh:%dm:%ds\n' $(($duracion/3600)) $(($duracion%3600/60)) $(($duracion%60)))
											else
											duracionview=""
											fi
											
											if [[ "$duracionview" != "" ]]; then
												echo "<font size='1' color='green'><b>"$temabase"</b></font></br>" >> ~/.gradio/data/tmp/playlistweb
												echo "$randomfile" "[""$duracionview""]"  >> ~/.gradio/data/tmp/playlistg3
												echo "$randomfilefinal" >> ~/.gradio/data/tmp/playlist
												~/.gradio/bin/GR_ClientSocketPlayList.gambas

											fi
										fi #fi 6
								else
									#echo "no encontre la carpeta" $line >> ~/.gradio/data/tmp/gr-$Fecha.log	
									randomfile=""
								fi #5 es directorio?
							fi #fi4
						fi #fi3
						hora1=`date  +%"-H"`
						playlist=`grep -c $ ~/.gradio/data/tmp/playlist`
						while [[ $playlist -ge $listatemas ]]; do #xhile 6
							sleep 3
							dropfinal=`cat ~/.gradio/data/tmp/ultimodrop`
							if [[ $dropfinal = "1" ]]; then
								sleep 3
								echo "0" > ~/.gradio/data/tmp/ultimodrop
							fi	
							playlist=`grep -c $ ~/.gradio/data/tmp/playlist`
						done #xhile 6
					else
						#playlist=$(($playlist+1)) #para salir del lazo infinito
						echo "playlist" $playlist				
					fi #fi2	
						nlinea=$(($nlinea+1))
						#Shell "sed -i '/^$/d' ~/.gradio/data/tmp/playlist*" Wait			
						~/.gradio/bin/cartucho.sh #&
				done #4			
			else #fi1
				echo "No existe parrilla musical programada a la $hora horas" > ~/.gradio/data/tmp/currentcomercial.txt
				playlist=$listatemas
				hora1=`date  +%"-H"`
				#echo "hora" $hora "hora1" $hora1
				sleep 3
				playlist=0
				nlinea=0
			fi #fi1
			sleep 3
		done # Xhile 3 playlist -le listatemas
		~/.gradio/bin/cartucho.sh 
		sleep 3
		hora1=`date  +%-H` 
	done #2 Xhile hora=hora1
	echo "sale hora hora1"
	echo "salio de lazo de hora con playlist $playlist" >> ~/.gradio/data/tmp/gr-$Fecha.log
done # Xhile 1 salir=0
